# TP IO 2

## Exercice 1


On considère un langage de programmation utilisé pour gérer une calculatrice. Il comporte les instructions suivantes:

- **ADD** *valeur* : ajoute une valeur, qui est a priori un double ; 
- **MULT** *valeur*  : multiplie par une valeur, qui est a priori un double ; 
- **CLEAR** efface le calcul courant (remet le résultat à 0);
- **PRIN**T affiche le résultat du calcul.

Les instructions opèrent sur le résultat actuel du calcul, qui commence à 0.

Ainsi, la séquence :

    CLEAR ADD 3 ADD 5 
    MULT 2 PRINT

va afficher le résultat 16.

### Question 1

Pour représenter en mémoire un programme écrit dans ce langage, on
décide d'utiliser le pattern *interpréteur.*

L'idée est que le programme est une suite d'instructions 
et que pour exécuter le programme, il suffit d'exécuter
successivement toutes les instructions.

Chaque commande sera représentée par un objet, qui disposera donc
d'une méthode `executer`

Pour que ça fonctionne, il faut que chaque type d'instruction (ADD,
CLEAR, etc.) soit représentée par une classe. Les paramètres de
l'instruction (quand il y en a) seront les variables d'instance de l'objet.

Par exemple, `ADD 3` sera représenté par un objet `ADDCommande`, avec un paramètre de 3. 

Les commandes ont besoin d'accéder à un certain nombre d'informations
communes. Dans notre cas, elles doivent avoir accès à un flux
d'entrées/sorties pour l'affichage, et surtout connaître le résultat
actuel du calcul sur lequel elles travaillent. C'est pour cela qu'on
introduit la classe `Contexte`.


- Lire et comprendre le code contenu dans le package `modele`, y compris les tests fournis ;
- vous inspirer de ce code pour proposer et coder trois nouvelles instructions :

    - MINUS *valeur* : soustrait *valeur* au résultat courant ;
    - DIV *valeur* : divise le résultat courant par *valeur* ;
    - SQR : met au carré le résultat courant.

- écrire un test pour SQR et un autre pour MINUS.

### Question 2

Complétez la classe `LecteurProgramme` en écrivant la méthode lire.
Écrire une méthode java qui prendra comme argument un `Reader`
et qui sera capable de lire un programme écrit dans ce petit
langage, et de construire sa représentation en mémoire (qui pourra ensuite être exécutée).

La structure de l'algorithme de lecture sera la suivante:


    tok.next() // on se place sur le premier token
    tant que tok.hasNextToken() :
        si c'est une instruction ADD: 
            tok.next() // on saute le ADD
            // on lit le nombre (ou on lève une erreur)
            // on termine en avançant
        sinon si c'est une instruction MULT : 
            l'analyser et la traiter
            ...
        sinon
            lever une exception pour signaler un token 
            inattendu.
        fin si
    fin tant que

Pour lire chaque commande, on pourra écrire une méthode auxiliaire, ce qui
éclaircira la structure du programme.  Je conseille fortement
d'adopter la convention suivante : *après la lecture d'une
  commande, le tokenizer contient le token qui **suit** la
  commande.*

Par exemple si mon programme est `ADD 3 MULT 2 PRINT`, la
méthode qui lit la commande `ADD 3` nous placera sur
`MULT`.

L'avantage de cette convention est qu'on sait où en en est, et qu'on
peut considérer qu'on a l'invariant : *quand on commence à lire
  une structure, le tokenizer est déjà positionné sur le premier token
  de cette structure.*

Ça impose « d'amorcer la pompe »  en lisant le premier token avant
toute autre opération.

### Question 3

On ajoute une nouvelle commandes au langage:

- SET *VAR* : donne à la variable *VAR* la valeur actuelle du calcul ;

Ensuite, les commandes ADD et MULT sont modifiées: elles peuvent
prendre comme argument un nombre, mais aussi un nom de variable
(auquel cas, la valeur ajoutée ou multipliée sera celle de la
variable).

On stoquera les valeurs des variables dans le `Contexte`, en utilisant une `HashMap<String,Double>`.

