/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cnam.ing39.io2.modele;

import java.io.Closeable;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * Pour l'instant, contient uniquement la valeur calculée par le programme
 * actuel.
 *
 * @author rosmord
 */
public class Contexte implements Closeable {

    /**
     * La valeur en cours de calcul.
     */
    private double valeurCourante = 0.0;

    /**
     * La sortie standard du programme.
     */
    private final PrintWriter out;

    /**
     * Construit un contexte, dont la sortie standard est l'écran.
     */
    public Contexte() {
        out = new PrintWriter(System.out);
    }

    public Contexte(PrintWriter out) {
        this.out = out;
    }

    public double getValeurCourante() {
        return valeurCourante;
    }

    public void setValeurCourante(double valeurCourante) {
        this.valeurCourante = valeurCourante;
    }

    public void write(String s) {
        out.print(s);
        out.flush();
    }

    @Override
    public void close() throws IOException {
        out.close();
    }
    
}
