/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cnam.ing39.io2.modele;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * La représentation d'un commandeList. (une liste de commandeList)
 *
 * @author rosmord
 */
public class Programme {
    private final List<Commande> commandeList= new ArrayList<>();
    
    public double executer(Contexte contexte) {
        for (Commande c: commandeList) {
            c.executer(contexte);
        }
        return contexte.getValeurCourante();
    }

    public void ajouter(Commande commande) {
       commandeList.add(commande);
    }

    @Override
    public String toString() {
       StringBuilder builder= new StringBuilder();
       for (Commande c: commandeList) {
           builder.append(c.toString()).append("\n");
       }
       return builder.toString();
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 47 * hash + Objects.hashCode(this.commandeList);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Programme other = (Programme) obj;
        if (!Objects.equals(this.commandeList, other.commandeList)) {
            return false;
        }
        return true;
    }
    
    
    

}
