/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cnam.ing39.io2.modele;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 * Ecrire un test d'intégration du programme.
 * @author rosmord
 */
public class ProgrammeTest {
    
    @Test
    public void testAddSimple() {
        Contexte contexte= new Contexte();       
        Programme programme= new Programme();
        programme.ajouter(new ADDCommande(10));
        programme.executer(contexte);
        assertEquals(10.0, contexte.getValeurCourante(), 1e-6);       
    }
    
    @Test
    public void testMultSimple() {
         Programme programme= new Programme();
         programme.ajouter(new ADDCommande(3.0));
         programme.ajouter(new MultCommande(4.0));
         Contexte contexte= new Contexte();
         programme.executer(contexte);
         
         assertEquals(12.0, contexte.getValeurCourante(), 1e-6);
    }
    
    @Test
    public void testPrint() throws IOException {
        StringWriter stringWriter= new StringWriter();
        Programme programme= new Programme();
        programme.ajouter(new ADDCommande(10));
        programme.ajouter(new PrintCommande());
        
        Contexte contexte= new Contexte(new PrintWriter(stringWriter));       
     
        programme.executer(contexte);  
        
        String textAffiche= stringWriter.toString();
        contexte.close();
        assertEquals("10.0\n", textAffiche);
    }
    
    @Test
    public void testToString() {
        Programme programme= new Programme();
        programme.ajouter(new ADDCommande(10));
        programme.ajouter(new PrintCommande());
        
        String attendu= "ADD 10.0\nPRINT\n";
        
        assertEquals(attendu, programme.toString());
    }
  
}
